﻿using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using Microsoft.VisualStudio.TestPlatform.UnitTestFramework;
using NavigationDemo.Logic.ViewModels;

namespace NavigationDemo.Logic.Test
{
  [TestClass]
public class GeocodeTest
{
[TestMethod]
public void TestLocationSearchHasResult()
{
  var waitHandle = new AutoResetEvent(false);
  var testVm = new GeocodeViewModel { SearchText = "Springerstraat Amersfoort Netherlands" };
  Deployment.Current.Dispatcher.BeginInvoke(async () =>
    {
      await testVm.SearchLocation();
      waitHandle.Set();
    });
  waitHandle.WaitOne(TimeSpan.FromSeconds(5));
  Assert.IsTrue(testVm.MapLocations.Any());
}

    [TestMethod]
    public void TestLocationSearchNoResult()
    {
      var waitHandle = new AutoResetEvent(false);
      var testVm = new GeocodeViewModel { SearchText = "Springerstraat" };
      Deployment.Current.Dispatcher.BeginInvoke(async () =>
      {
        await testVm.SearchLocation();
        waitHandle.Set();
      });
      waitHandle.WaitOne(TimeSpan.FromSeconds(5));
      Assert.IsFalse(testVm.MapLocations.Any());
    }



    [TestMethod]
    public async Task TestLocationWrong1()
    {
      var testVm = new GeocodeViewModel { SearchText = "Springerstraat Amersfoort Netherlands" };
      await testVm.SearchLocation();
      Assert.IsTrue(testVm.MapLocations.Any());
    }

    [TestMethod]
    public void TestLocationWrong2()
    {
      var testVm = new GeocodeViewModel 
      { SearchText = "Springerstraat Amersfoort Netherlands" };
      Deployment.Current.Dispatcher.BeginInvoke(async () => await testVm.SearchLocation());
      Assert.IsTrue(testVm.MapLocations.Any());
    }
  }
}
