﻿using System.Device.Location;
using System.Windows;
using Microsoft.Phone.Maps.Controls;
using Wp7nl.Behaviors;

namespace Wp8nl.Behaviors
{
  public class TapToCoordinateBehavior : SafeBehavior<Map>
  {
    protected override void OnSetup()
    {
      AssociatedObject.Tap += AssociatedObjectTap;
    }

    void AssociatedObjectTap(object sender, System.Windows.Input.GestureEventArgs e)
    {
      var tapPosition = e.GetPosition((UIElement)sender);
      TappedCoordinate = AssociatedObject.ConvertViewportPointToGeoCoordinate(tapPosition);
    }

    protected override void OnCleanup()
    {
      AssociatedObject.Tap -= AssociatedObjectTap;
    }

    #region TappedCoordinate

    /// <summary>
    /// TappedCoordinate Property name
    /// </summary>
    public const string TappedCoordinatePropertyName = "TappedCoordinate";

    public GeoCoordinate TappedCoordinate
    {
      get { return (GeoCoordinate)GetValue(TappedCoordinateProperty); }
      set { SetValue(TappedCoordinateProperty, value); }
    }

    /// <summary>
    /// TappedCoordinate Property definition
    /// </summary>
    public static readonly DependencyProperty TappedCoordinateProperty = DependencyProperty.Register(
        TappedCoordinatePropertyName,
        typeof(GeoCoordinate),
        typeof(TapToCoordinateBehavior),
        new PropertyMetadata(default(GeoCoordinate)));

    #endregion
  }
}
